
function onLoad()
{
	loadTags();
}

//
// Loads the tags
//
function loadTags()
{
	try
	{
	    var tagsTree = document.getElementById('delicious-sidebar-tags-tree');
		var xmlDOM = deliciousService.getTags();
	    
	    var root = xmlDOM.documentElement;
	    var myTags = root.getElementsByTagName("tag");
        
		var RDF =
		Components.classes['@mozilla.org/rdf/rdf-service;1'].getService();
		RDF = RDF.QueryInterface(Components.interfaces.nsIRDFService);
		
		var RDFC = Components.classes['@mozilla.org/rdf/container;1'].getService();
		RDFC = RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);
		
		var RDFCUtils =
		Components.classes['@mozilla.org/rdf/container-utils;1'].getService();
		RDFCUtils =
		RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);
		
		var ds =
		Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance();
		ds = ds.QueryInterface(Components.interfaces.nsIRDFDataSource);
		
		// create our root nodes
		var rootNode = RDF.GetResource("urn:root");
		var sequenceNode = RDF.GetResource("urn:root:seq");
		// Root node in tree
		ds.Assert(rootNode, RDF.GetResource("http://delicious.mozdev.org/RDF#tags"), sequenceNode, true);
		
		RDFCUtils.MakeSeq(ds, sequenceNode);
		RDFC.Init(ds, sequenceNode);
		
		tagsTree.database.AddDataSource(ds);
        
	    for (var i = 0; i < myTags.length; i++) 
	    {
	        var tagName = myTags[i].getAttribute("tag");
	        var count = myTags[i].getAttribute("count");
	        
            var item = document.createElement('treeitem');
            var row = document.createElement('treerow');
            
            var newURI = "urn:root:file:" + i;

			// add the new element
			RDFC.AppendElement(RDF.GetResource(newURI));
			
			ds.Assert(RDF.GetResource(newURI),
				RDF.GetResource("http://delicious.mozdev.org/RDF#name"),
				RDF.GetLiteral(tagName), true);
			
			ds.Assert(RDF.GetResource(newURI),
				RDF.GetResource("http://delicious.mozdev.org/RDF#count"),
				RDF.GetLiteral(count), true);
	    }
         tagsTree.builder.rebuild();
	}
	catch(e)
	{
		alert(e);
	}
}


function reloadTags()
{
    var tree = document.getElementById('delicious-sidebar-tags-tree');

	clearTree(tree);
    loadTags();
}

function clearFeeds()
{
	var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
	clearTree(tree);
}

//
// Reloads the selected feeds
//
function reloadFeeds()
{
	var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
	var datasources = tree.database.GetDataSources();
	
	alert("Reload is not working currently. 304 HTTP code is not handled correctly by Mozilla.\nWorking on a fix.");
    
    // Possible solution??
	while(datasources.hasMoreElements()){
	        var datasource = datasources.getNext();
	        datasource = datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	        // reload asyncronously. Does not seem to know what 304 is
	        datasource.Refresh(false);
	}
}

//
// Displays the selected tags
//
function loadSelectedTag()
{
    const tagsTree = document.getElementById('delicious-sidebar-tags-tree');
    const tag = tagsTree.view.getCellText(tagsTree.currentIndex, "name");

    if(tagsTree.selectedCount == 0)
    {
        alert("Click on a tag");
        return false;
    }
    else
    {
    	loadFeed(tag);
        return true;
    }
}

//
// Load a feed into the tree
//
function loadFeed(tag)
{
	try
	{
		var username = deliciousService.getUsername();
		var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var feedUrl = "http://del.icio.us/rss/" + username;
		
		if(tag != null)
		{
			feedUrl += "/" + tag;
		}
		
		var datasource = rdfService.GetDataSource(feedUrl);
		
		var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
		
		// This has to match the channel in the feed
		tree.ref = "http://del.icio.us/" + username + "/" + tag;
		tree.database.AddDataSource(datasource);
		tree.builder.rebuild();
	}
	catch(e)
	{
		alert(e);
	}
}

//
// Load link
//
function onDblClick()
{
    var tree = document.getElementById('delicious-sidebar-bookmarks-tree');
    var bookmarkUrl = tree.view.getCellText(tree.currentIndex, "link_column");
    window._content.document.location.href = bookmarkUrl;
    return;
}

//
// Rename tag
//
function renameTag()
{
    const tagsTree = document.getElementById('delicious-sidebar-tags-tree');
    const tag = tagsTree.view.getCellText(tagsTree.currentIndex, "name");
	const count = tagsTree.view.selection.getRangeCount();
	
    if(count == 0)
    {
        alert("Click on a tag");
        return false;
    }
    else
    {
    	var name = prompt("Enter new name for tag '" + tag + "'");
		if(name.length > 0)
		{
	    	alert(deliciousService + name);
	    	deliciousService.renameTag(tag, name);
			return true;
	    }
		else
		{
			return false;
		}
    }
}

//
// Removes all datasources from a tree
//
function clearTree(tree)
{
	var datasources = tree.database.GetDataSources();
	while(datasources.hasMoreElements()){
	        var datasource = datasources.getNext();
	        datasource = datasource.QueryInterface(Components.interfaces.nsIRDFDataSource);
	        tree.database.RemoveDataSource(datasource);
	}

	tree.builder.rebuild();
}
